<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="pl">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.7"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Robomap: Plik źródłowy SerialPort.hpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">Robomap<span id="projectnumber">&#160;0.1</span>
   </div>
   <div id="projectbrief">RM</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Wygenerowano przez Doxygen 1.9.7 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',false,false,'search.php','Szukaj');
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('_serial_port_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle"><div class="title">SerialPort.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="_serial_port_8hpp.html">Idź do dokumentacji tego pliku.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#ifndef SERIALPORT_HPP</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="preprocessor">#define SERIALPORT_HPP</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &lt;condition_variable&gt;</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;cstring&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;fcntl.h&gt;</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;cstdio&gt;</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &lt;sys/types.h&gt;</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;sys/stat.h&gt;</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#include &lt;unistd.h&gt;</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &quot;<a class="code" href="_robot_data_8hpp.html">RobotData.hpp</a>&quot;</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#include &quot;<a class="code" href="odbieranie_8hh.html">odbieranie.hh</a>&quot;</span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#include &quot;<a class="code" href="transparam_8hh.html">transparam.hh</a>&quot;</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="_serial_port_8hpp.html#acdd0eacf8c0ad94beabef95f32d78009">   29</a></span><span class="preprocessor">#define FRAME_LIMIT 50</span></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="keyword">extern</span> std::condition_variable <a class="code hl_variable" href="_serial_port_8hpp.html#aad7bbf4191e375baee5f99ed26694706">start</a>;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="keyword">extern</span> std::mutex <a class="code hl_variable" href="_serial_port_8hpp.html#a1b56d40ec3cfbf9e16772d3c02374e9f">cm</a>;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="class_serial_port.html">   41</a></span><span class="keyword">class </span><a class="code hl_class" href="class_serial_port.html">SerialPort</a></div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>{</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">   49</a></span>    <a class="code hl_class" href="class_robot_data.html">RobotData</a> <a class="code hl_variable" href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">data</a>;</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">   53</a></span>    <span class="keywordtype">bool</span> <a class="code hl_variable" href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">keep_reading</a> = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">   57</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a> = -1;</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="class_serial_port.html#a19e9af50f81a100e0e9bbaa5e2027b3d">   63</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="class_serial_port.html#a19e9af50f81a100e0e9bbaa5e2027b3d">returnDecriptor</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code hl_variable" href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">port_desc</a>; }</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    <a class="code hl_function" href="class_serial_port.html#aca7d6ec84770df9715926afd3226454b">SerialPort</a>();</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno"><a class="line" href="class_serial_port.html#a04a364848114cc5e6d9fb618b6b0a66d">   75</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#a04a364848114cc5e6d9fb618b6b0a66d">keepReading</a>() { <span class="keywordflow">return</span> <a class="code hl_variable" href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">keep_reading</a>; }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">receiveData</a>();</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#ab8617347c0bd495e80d39e563ec8e750">startConnection</a>();</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="class_serial_port.html#a58d7a924c500dbbd169ab7ed0f60afef">endConnection</a>();</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno"><a class="line" href="class_serial_port.html#aa62756463c259f5a8e5d203227109322">   95</a></span>    <a class="code hl_class" href="class_robot_data.html">RobotData</a> * <a class="code hl_function" href="class_serial_port.html#aa62756463c259f5a8e5d203227109322">returnRobotData</a>() { <span class="keywordflow">return</span> &amp;<a class="code hl_variable" href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">data</a>; }</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>};</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span><span class="keywordtype">bool</span> <a class="code hl_function" href="_serial_port_8hpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *data_frame, <a class="code hl_class" href="class_robot_data.html">RobotData</a> *data, <span class="keywordtype">int</span> data_length);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span><span class="keywordtype">bool</span> <a class="code hl_function" href="_serial_port_8hpp.html#a0466d31f193efdfcc7b4d13472a27254">checkCRC</a>(<span class="keywordtype">char</span> *data_frame, <span class="keywordtype">int</span> data_length, <span class="keywordtype">char</span> crc);</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span><span class="keywordtype">char</span> <a class="code hl_function" href="_serial_port_8hpp.html#a750bdeca814dbfc7b7010d4b30c56023">crc8</a>(<span class="keywordtype">char</span> *data_frame, <span class="keywordtype">int</span> data_length);</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span><span class="keywordtype">void</span> <a class="code hl_function" href="_serial_port_8hpp.html#a6362cdaadde6e3f843a85a3713bb1e0c">process</a>(<a class="code hl_class" href="class_serial_port.html">SerialPort</a> *serial);</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span><span class="preprocessor">#endif </span><span class="comment">// SERIALPORT_HPP</span></div>
<div class="ttc" id="a_robot_data_8hpp_html"><div class="ttname"><a href="_robot_data_8hpp.html">RobotData.hpp</a></div><div class="ttdoc">Definicja klasy RobotData.</div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a0466d31f193efdfcc7b4d13472a27254"><div class="ttname"><a href="_serial_port_8hpp.html#a0466d31f193efdfcc7b4d13472a27254">checkCRC</a></div><div class="ttdeci">bool checkCRC(char *data_frame, int data_length, char crc)</div><div class="ttdoc">Sprawdza zgodność sumy kontrolnej CRC.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00150">SerialPort.cpp:150</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a1b56d40ec3cfbf9e16772d3c02374e9f"><div class="ttname"><a href="_serial_port_8hpp.html#a1b56d40ec3cfbf9e16772d3c02374e9f">cm</a></div><div class="ttdeci">std::mutex cm</div><div class="ttdef"><b>Definition</b> <a href="main_8cpp_source.html#l00008">main.cpp:8</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a21626d35c8ce984e1085d6224f0ba720"><div class="ttname"><a href="_serial_port_8hpp.html#a21626d35c8ce984e1085d6224f0ba720">parseDataFrame</a></div><div class="ttdeci">bool parseDataFrame(const char *data_frame, RobotData *data, int data_length)</div><div class="ttdoc">Analizuje otrzymaną ramkę danych.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00102">SerialPort.cpp:102</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a6362cdaadde6e3f843a85a3713bb1e0c"><div class="ttname"><a href="_serial_port_8hpp.html#a6362cdaadde6e3f843a85a3713bb1e0c">process</a></div><div class="ttdeci">void process(SerialPort *serial)</div><div class="ttdoc">Funkcja wykonywana przez wątek czytający.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00194">SerialPort.cpp:194</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_a750bdeca814dbfc7b7010d4b30c56023"><div class="ttname"><a href="_serial_port_8hpp.html#a750bdeca814dbfc7b7010d4b30c56023">crc8</a></div><div class="ttdeci">char crc8(char *data_frame, int data_length)</div><div class="ttdoc">Oblicza sumę kontrolną otrzymanej ramki danych.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00166">SerialPort.cpp:166</a></div></div>
<div class="ttc" id="a_serial_port_8hpp_html_aad7bbf4191e375baee5f99ed26694706"><div class="ttname"><a href="_serial_port_8hpp.html#aad7bbf4191e375baee5f99ed26694706">start</a></div><div class="ttdeci">std::condition_variable start</div><div class="ttdef"><b>Definition</b> <a href="main_8cpp_source.html#l00007">main.cpp:7</a></div></div>
<div class="ttc" id="aclass_robot_data_html"><div class="ttname"><a href="class_robot_data.html">RobotData</a></div><div class="ttdoc">Zbiór wszystkich danych otrzymywanych z robota.</div><div class="ttdef"><b>Definition</b> <a href="_robot_data_8hpp_source.html#l00017">RobotData.hpp:18</a></div></div>
<div class="ttc" id="aclass_serial_port_html"><div class="ttname"><a href="class_serial_port.html">SerialPort</a></div><div class="ttdoc">Modeluje port szeregowy.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00041">SerialPort.hpp:42</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a04a364848114cc5e6d9fb618b6b0a66d"><div class="ttname"><a href="class_serial_port.html#a04a364848114cc5e6d9fb618b6b0a66d">SerialPort::keepReading</a></div><div class="ttdeci">bool keepReading()</div><div class="ttdoc">Metoda decydująca o kontynuacji czytania.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00075">SerialPort.hpp:75</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a19e9af50f81a100e0e9bbaa5e2027b3d"><div class="ttname"><a href="class_serial_port.html#a19e9af50f81a100e0e9bbaa5e2027b3d">SerialPort::returnDecriptor</a></div><div class="ttdeci">int returnDecriptor() const</div><div class="ttdoc">Zwraca deskryptor pliku.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00063">SerialPort.hpp:63</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a222bb0e736430908b2145a1e24459d67"><div class="ttname"><a href="class_serial_port.html#a222bb0e736430908b2145a1e24459d67">SerialPort::port_desc</a></div><div class="ttdeci">int port_desc</div><div class="ttdoc">Deskryptor pliku portu szeregowego.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00057">SerialPort.hpp:57</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a343697523d58e3812ba0999cfa122f2d"><div class="ttname"><a href="class_serial_port.html#a343697523d58e3812ba0999cfa122f2d">SerialPort::data</a></div><div class="ttdeci">RobotData data</div><div class="ttdoc">Dane z robota.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00049">SerialPort.hpp:49</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a58d7a924c500dbbd169ab7ed0f60afef"><div class="ttname"><a href="class_serial_port.html#a58d7a924c500dbbd169ab7ed0f60afef">SerialPort::endConnection</a></div><div class="ttdeci">bool endConnection()</div><div class="ttdoc">Kończy połączenie z portem szeregowym.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00050">SerialPort.cpp:50</a></div></div>
<div class="ttc" id="aclass_serial_port_html_a97cc08ccce84780fd625ea8ae4dcc917"><div class="ttname"><a href="class_serial_port.html#a97cc08ccce84780fd625ea8ae4dcc917">SerialPort::keep_reading</a></div><div class="ttdeci">bool keep_reading</div><div class="ttdoc">Zmienna decydująca o działaniu wątku.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00053">SerialPort.hpp:53</a></div></div>
<div class="ttc" id="aclass_serial_port_html_aa62756463c259f5a8e5d203227109322"><div class="ttname"><a href="class_serial_port.html#aa62756463c259f5a8e5d203227109322">SerialPort::returnRobotData</a></div><div class="ttdeci">RobotData * returnRobotData()</div><div class="ttdoc">Zwraca wskaźnik do obiektu z danymi robota.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8hpp_source.html#l00095">SerialPort.hpp:95</a></div></div>
<div class="ttc" id="aclass_serial_port_html_ab8617347c0bd495e80d39e563ec8e750"><div class="ttname"><a href="class_serial_port.html#ab8617347c0bd495e80d39e563ec8e750">SerialPort::startConnection</a></div><div class="ttdeci">bool startConnection()</div><div class="ttdoc">Otwiera port szeregowy.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00028">SerialPort.cpp:28</a></div></div>
<div class="ttc" id="aclass_serial_port_html_aca7d6ec84770df9715926afd3226454b"><div class="ttname"><a href="class_serial_port.html#aca7d6ec84770df9715926afd3226454b">SerialPort::SerialPort</a></div><div class="ttdeci">SerialPort()</div><div class="ttdoc">Inicjalizuje obiekt klasy SerialPort.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00013">SerialPort.cpp:13</a></div></div>
<div class="ttc" id="aclass_serial_port_html_af29d6aadc436a6440cfa66fbf8c403ad"><div class="ttname"><a href="class_serial_port.html#af29d6aadc436a6440cfa66fbf8c403ad">SerialPort::receiveData</a></div><div class="ttdeci">bool receiveData()</div><div class="ttdoc">Odbiera dane z portu.</div><div class="ttdef"><b>Definition</b> <a href="_serial_port_8cpp_source.html#l00069">SerialPort.cpp:69</a></div></div>
<div class="ttc" id="aodbieranie_8hh_html"><div class="ttname"><a href="odbieranie_8hh.html">odbieranie.hh</a></div></div>
<div class="ttc" id="atransparam_8hh_html"><div class="ttname"><a href="transparam_8hh.html">transparam.hh</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_4aa64b0872d36146e049722e293482e3.html">prj</a></li><li class="navelem"><a class="el" href="dir_72345776cd6700fb0dedb8f1faaa0c00.html">inc</a></li><li class="navelem"><a class="el" href="_serial_port_8hpp.html">SerialPort.hpp</a></li>
    <li class="footer">Wygenerowano przez <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.7 </li>
  </ul>
</div>
</body>
</html>
